// XLarge.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "XLarge.h"

#define XL_TIMER_ON
#include "CPUTimer.h"

#include <Windows.h>

int _tmain(int argc, _TCHAR* argv[])
{
	CPUTimer timer;
	PXLARGE a, b, c, d, e;
	a = xl_create(4);
	b = xl_create(4);
	c = xl_create(4);
	d = xl_create(4);
	e = xl_create(4);
	
	for (int B = 1; B < 6; ++B)
	{
		printf("%d * 32 Bit Mod (64 Repeats)\n", (1 << B));
		timer.Reset();
		for (int i = 0; i < 1; ++i)
		{
			int r1 = rand();
			int r2 = rand() % (1 << (B + 1)) + (1 << (B + 1)) * 32;
			int r3 = rand();
			int r4 = rand() % (1 << B) + (1 << B) * 32;
			int r5 = rand();
			int r6 = rand();

			xl_init1(a, r1);
			xl_shl(a, r2);
			xl_init1(b, r3 + 1);
			xl_shl(b, r4);
			xl_add1(a, r5);
			xl_add1(b, r6);

			xl_mod(a, b, c, d);
		}
		timer.Print(stdout, "\tDCMod : %lfs.\n");
	}

	timer.Reset();
	for (int i = 1; i <= 2048; ++i)
	{
		xl_atof(a, "111111111111111111111111111", 0);
		xl_shl(a, i * 256);
		xl_atof(b, "1000000000000000", 0);
		//xl_shl(b, i*2);

		//xl_mod(a, b, c);
		/*xl_print(a, stdout, -1);
		printf(" / ");
		xl_print(b, stdout, -1);
		printf(" = \n");
		xl_print(c, stdout, -1);
		printf(" ... ");
		xl_print(d, stdout, -1);
		printf("\n");

		xl_mul(a, b, c);
		xl_add(a, d);
		xl_print(a, stdout, -1);
		printf("\n\n\n");*/
	}
	timer.Print(stdout, "%lfs.\n");

	/*for(int i = 16; i < 128; i += 4)
	{
		xl_sqrt(b, a, i);
		xl_print(b, stdout, -1);
		printf("\n");
	}*/
	/*for(int i = -256; i < 256; i += 1)
	{
		xl_init(a, i);
		xl_shr(a, 8);
		//xl_cos(b, a, 128);
		//xl_print(b, stdout, -1);
		printf("\n");
		//xl_sin(c, a, 128);
		//xl_print(c, stdout, -1);
		printf("\n");
		xl_acos(d, a, 256);
		xl_print(d, stdout, 128);
		printf("\n");
	}*/
	/*for(int i = 4; i < 128; i +=4)
	{
		xl_exp(b, a, i);
		xl_print(b, stdout);
		printf("\n");
	}*/

	/*QueryPerformanceCounter(&t1);
	for(int i = 0; i < 32; ++i)
	{
		xl_init(b, (i & 31) + 1);
		xl_inv(a, b, 256);
		xl_print(a, stdout);
		printf("\n");
	}
	QueryPerformanceCounter(&t2);
	printf("%ld", t2.QuadPart - t1.QuadPart);*/
	printf("\nFinish.\n");
	while(1);
	return 0;
}

